Device = 16F1825         ' PROTON BASIC compiler 3.5.5.5
Declare Create_Coff = On  ' use with mplab sim to debug 
 
Config1 fosc_intosc,mclre_off,pwrte_on,boren_off,wdte_off,fcmen_off,ieso_off ,clkouten_off 'ra4
 
Config2 LVP_OFF, PLLEN_on, wrt_off ,stvren_off

Declare Xtal 32   ''Declare Xtal 32   '' not sure since using PLL
Declare Float_Display_Type = Fast 

' sync=0  brgh=1 brg16=1

$define b9600 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0x3 : SPBRGL=0x40
$define b19200 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0x1 : SPBRGL=0xA0
$define b38400 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0x0 : SPBRGL=0xD0

''$define b78600 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0x0 : SPBRGL=0x68

$define b57600 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0x0 : SPBRGL=0x8A
$define b115200 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0 : SPBRGL = 68   
$define b230400 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0 : SPBRGL = 34    
$define b460800 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0 : SPBRGL = 16   
$define b921600 () TXSTA.4=0 : TXSTA.2=1 : BAUDCON.3=1 : SPBRGH=0 : SPBRGL = 8 
$define EnbRx ()
$define EnbTx ()
$define Start_Cnts () TMR1L=0 : TMR1H=0 : TMR2=0 : T1CON.0=1 : T2CON.2=1                      
$define Stop_Cnts () T1CON.0=0 : T2CON.2=0 : TCTR=T1CTR                                                                                                                                                      

$define HRS80P () GoSub CrLf : X = "+" : Y = 80 : GoSub CharOut
$define HRS80M () GoSub CrLf : X = "-" : Y = 80 : GoSub CharOut 
$define HRS80E () GoSub CrLf : X = "=" : Y = 80 : GoSub CharOut
'''$define MRcall () C = "R" : GoSub MsgOut



                                                                                                                                 
'----------------sync -------brgh -------brg16 --------- spbrg=832 => 0x340-----
'Declare Hserial_Baud = 9600 ' Set baud rate to 9600
'Declare Hserial_RCSTA = %10010000 ' Enable continuous receive
'Declare Hserial_TXSTA = %00100000 ' Enable transmit and asynchronous mode
'Declare Hserial_Clear = On ' Clear the buffer before receiving    

                 
'------------------------------------------------------------------------------- 
' ADDR = 0 -> 39    K 0.1
K1 EData 0x00200001    ' ppm = 0001  pulsecnt = 32
   EData 342,0xffff    ' ppm = 342   pulsecnt = ----
   EData 700,0xffff    ' ppm = 700   pulsecnt = ----
   EData 1000,34770    ' ppm = 1000  pulsecnt = 34770
   EData 1400,0xffff   ' ppm = 1400  pulsecnt = ----
   EData 1840,45350    ' ppm = 1840  pulsecnt = 45350
   EData 2000,48550    ' ppm = 2000  pulsecnt = 48550
   EData 2450,0xffff   ' ppm = 2450  pulsecnt = ----
   EData 2800,0xffff   ' ppm = 2800  pulsecnt = ----
   EData 3260,54350    ' ppm = 3260  pulsecnt = 54350
' ADDR = 40 -> 79   K 1.0
 
K2 EData 0x00200001    ' ppm = 0001  pulsecnt = 32
   EData 500,0xffff,   ' ppm = 500   pulsecnt = ----                   
   EData 1000,34770    ' ppm = 1000  pulsecnt = 34770
   EData 1500,0xffff   ' ppm = 1500  pulsecnt = ---- 
   EData 1800,45350    ' ppm = 1800  pulsecnt = 45350
   EData 2000,48550    ' ppm = 2000  pulsecnt = 48550
   EData 3260,54350    ' ppm = 3260  pulsecnt = 54350 
   EData 3400,55100    ' ppm = 3400  pulsecnt = 55100
   EData 4000,0xffff   ' ppm = 4000  pulsecnt = ---- 
   EData 4500,0xffff   ' ppm = 4500  pulsecnt = ---- 
' ADDR = 80 -> 119  k 10
 
K3 EData 0x00200001    ' ppm = 0001  pulsecnt = 32
   EData 1000,34770    ' ppm = 1000  pulsecnt = 34770 
   EData 1800,45350    ' ppm = 1800  pulsecnt = 45350                 
   EData 2000,48550    ' ppm = 2000  pulsecnt = 48550
   EData 3260,54350    ' ppm = 3260  pulsecnt = 54350
   EData 3400,55100    ' ppm = 3400  pulsecnt = 55100
   EData 4000,0xffff   ' ppm = 4000  pulsecnt = ----
   EData 7000,0xffff   ' ppm = 7000  pulsecnt = ---- 
   EData 8000,0xffff   ' ppm = 8000  pulsecnt = ---- 
   EData 9000,0xffff   ' ppm = 9000  pulsecnt = ---- 
' ADDR = 120 -> 159 K ??
 
K4 EData 0x00200001    ' ppm = 0001  pulsecnt = 32
   EData 1000,34770    ' ppm = 1000  pulsecnt = 34770 
   EData 1800,45350    ' ppm = 1800  pulsecnt = 45350                 
   EData 2000,48550    ' ppm = 2000  pulsecnt = 48550
   EData 3260,54350    ' ppm = 3260  pulsecnt = 54350
   EData 3400,55100    ' ppm = 3400  pulsecnt = 55100
   EData 4000,0xffff   ' ppm = 4000  pulsecnt = ----
   EData 7000,0xffff   ' ppm = 7000  pulsecnt = ---- 
   EData 8000,0xffff   ' ppm = 8000  pulsecnt = ---- 
   EData 9000,0xffff   ' ppm = 9000  pulsecnt = ---- 
' ADDR = 160 -> 199 k ??
 
K5 EData 0x00200001    ' ppm = 0001  pulsecnt = 32
   EData 1000,34770    ' ppm = 1000  pulsecnt = 34770 
   EData 1800,45350    ' ppm = 1800  pulsecnt = 45350                 
   EData 2000,48550    ' ppm = 2000  pulsecnt = 48550
   EData 3260,54350    ' ppm = 3260  pulsecnt = 54350
   EData 3400,55100    ' ppm = 3400  pulsecnt = 55100
   EData 4000,0xffff   ' ppm = 4000  pulsecnt = ----
   EData 7000,0xffff   ' ppm = 7000  pulsecnt = ---- 
   EData 8000,0xffff   ' ppm = 8000  pulsecnt = ---- 
   EData 22727,64100   ' ppm = 9000  pulsecnt = ----     
' ADDR = 200       
 
Erev  EData "ProtonBC 3.5.5.5 "                          ' 200> "ProtonBC 3"
      EData "EC-16F1825 Mike ver 1.11",0   '  > ".5.5.5 EC-" 
            
KPRB  EData "1"                ' ascii probe constant "1,2,3,??,?? 
 
KDAT  EData 1                ' 1,10,100,150,200 
 
'
' 1> get count [ average of 16 counts ]
' 2> find close value in Eprom save eprom address above and below value
' 3> address above = high ppm   address below = low ppm 
' 4> address low * 50 = low ppm  and contains calibration count low
' 5> address high * 50 = high ppm and contains calibration count high
' 6> probe low freq  ppm - counts
' 7> probe high freq  ppm - counts
' 8> slope is  (ppm Hi - ppm Lo) / ( freq Hi - freq Lo)
' 9>   using y = mx +b   ==>   b = y - mx  ==>   b =  (ppm Lo) - (slope * freqLo)
' 10>  computed ppm correction = (ppm Lo) - (slope * freqLo)
' 11> conductivity = [slope * freq-new ] +/- b
'
'                     me thinks
'-------------------------------------------------------------------------------    
'                       PROBE    1/16 titanium wire  
'               +-------------------+     
'               |                   |<--.425-> |
'             ^^^^^^________________|__________|  _________
'     adjust length ________________|__________|  ____   |
'             ^^^^^^                |              |     |
'               |                   |   .305 c-c   |     .356
'               |                   |     8mm     .230   | 9.09mm
'             ^^^^^^________________|__________   _|__   |
'                   ________________|__________|  _______|___
'           / ^^^^^^                |\            .585mm
'  threads /     |                  | \_press fit 
'                +------------------+
'
'   threaded 3/16 brass rod drilled out to accept 1/16 titanium wire 
'   slotted to accept screw driver for use to fine tune length
'
' PROBE can be about any dimensions, accuracy will be in the calibration points
'   
' Ideally need several good calibration solutions [ie] ppm / 100 = eeprom address
'    500/100= address 5&6 contain pulse count associated with 500 ppm
'
'  0ppm  500ppm  1000ppm 1500ppm 2000ppm 2500ppm 3000ppm 3500ppm 4000ppm 4500ppm 
'  5000ppm 5500ppm 6000ppm 6500ppm 7000ppm 7500ppm 8000ppm 8500ppm
'  9000ppm 9500ppm 10000ppm 10500ppm 
'-------------------------------------------------------------------------------
'                                  PIC16F1825
'                                   __    __
'                                  |  \__/  |
'                              Vdd |1     14| Vss                          
'                            T1CKI |2     13|  RA0/TX   
'                            RA4   |3     12|  RA1/RX    
'                         RA3/MCLR |4     11|  RA2      
'                          RX  Rc5 |5     10| Rc0 An4
'                          Tx  Rc4 |6      9| Rc1 an5
'                          an7 Rc3 |7      8| Rc2 an6
'    Probe                         |________| 
'     |  |                                                        
'  |-------|                     
'  |555 ctr|-------------+                   
'  |-------|             |                                  
'      |______________   |                         
'                     |  |                        
' ___ DS9490R         |  |    +5     gnd        
'|   |---->-3 TX rs23 |  |    _|_______|___         
'|   |                |  |   |1 vdd 14 Vss |   
'|   |                |  +---|2 RA5  13 RA0|--DAC-----          
'|PC |DQ |->          +------|3 RA4        |                 
'|  3|--->--->--+            |       12 RA1|--        |---------|
'|   |          |     sel0+--|4 RA3  11 RA2|-----DQ---|DS18B20P |--gnd 0 V                     
'|__2|----<--+  +->- Rx <--  |5 RC5        |          |DS18b20+ |--+5_ Or gnd            
'            |               |      10 RC0 |          |---------|              
'            +--<--  TX <--  |6 RC4  9 RC1 |                    
'                            |7 RC3  8 RC2 |           
'                            |_____________|                    
'                                                                
'                                                                         
'                                                             
'                                                                             3                                                                           
'------------------------------------------------------------------------------- 
Symbol DQ = PORTA.2         ' Place the DS18B20 on bit-1 of PortA
Symbol Quanta5 = 5.0 / 1024         '
Symbol Quanta4 = 4          '4.096 / 1024       '   FVRCON 
Symbol Quanta2 = 2          '2.048 / 1024       '
 

Dim Inbyte As Byte
Dim Z1 As Byte
Dim Kx As Byte
Dim Kz As Byte


Dim C As Byte
Dim Rx As Float
Dim Ms As Float
Dim Ix As Float
Dim Vx As Float
Dim Tx As Float
Dim AdrLo As Byte
Dim AdrHi As Byte

Dim Cx As Float
Dim W As Byte
Dim V As Byte

Dim T1x As Vx           ' aliasas
Dim T2x As Cx           ' aliasas

Dim Work As Dword
Dim BaudSel As Byte 
Dim T2cnt As Byte 
Dim IntCnt As Byte
 

Dim ExtCnt As Dword
Dim Tmr1Counter As Dword
Dim TemperatureCnt As Dword
Dim AdjustedCnt1 As Dword
Dim AdjustedCnt2 As Dword

Dim AvgPulseCount As Word
Dim AvgTemperature As Word 
Dim TCTR As Word
Dim T1CTR As TMR1L.Word      'alisas
Dim ADC  As ADRESL.Word      'alisas
Dim ADC0 As  Word 
Dim ADC1 As  Word
Dim FHi As Word
Dim FLo As Word
Dim Ycnt As Word
Dim Xcnt As Word

Dim Delta_Freq As Word 
Dim Delta_PPM As Dword
Dim C_deg As Float
Dim F_deg As Float
Dim Slope As Float
Dim PPM_correction As Float
Dim PPM_Now_Temp As Dword
'Dim Resistor As Word
Dim Found As Byte
Dim IntCntA As Byte
Dim X As Byte
Dim Y As Byte


Dim B20Str[10] As Byte   ''' as string * 10
Dim b20str#0H As b20str#1 
Dim Temp As b20str#0.Word
Dim THR As b20str#2
Dim TLR As b20str#3 
Dim DSFig As b20str#4
Dim RSV5 As b20str#5
Dim RSV6 As b20str#6
Dim RSV7 As b20str#7
Dim CRC As b20str#8

'Dim Tempx As Word          ' Holds the temperature value
'Dim THR As Byte 
' Byte
'Dim DSFig As Byte
'Dim RSV5 As Byte
'Dim RSV6 As Byte
'Dim RSV7 As Byte 
'Dim CRC As Byte   

Dim CalibF As Temp           ' alisas
'-----------------------
Dim BaudAsc As String * 6     ' ascii baud reference 
Dim Parasite As Byte
Dim Pdata As Byte        ' P-parasite  + uses 5v 
'aliases 

'Dim NEW As Word  
Dim RxCR As Byte                 ' 2^7=cr rcv'd       0-63 valid position of cr
Dim RxIn As Byte                 '  store incoming data this index 0-63
Dim RxOut As Byte                '  data byte out location
Dim RxChar As Byte
Dim RxOld As Byte
Dim cidx As Byte
Dim PK As Byte                   ' probe K

Dim CmdW As Dword
Dim CMD  As String * 10           ' extracted cmd from RxBuf 
Dim CMD1 As String * 4
Dim RxBuf As String *  64         ' byte array with 64 bytes
Dim ED As String *32

Dim ESlot As Dword
Dim Eppm As ESlot.Word0
Dim Ecnt As ESlot.Word1 

Dim PPMhi As Word

Dim PPMlo As Word
Dim Clen As Byte                 ' length of cmd 
Dim AvgCnt As Byte               ' track sample s
Dim Command As Byte 


Dim AdjustedPPM1 As Dword
Dim AdjustedPPM2 As Dword

Dim KADR As Byte
Dim KDATA As Byte
Dim KTA As Byte                   ' K table address
Dim PPMLoad As Word 
Dim KTALoad As Byte
Dim KTAVal As Byte
Dim KTASlot As Byte
Dim CRCDATA As Byte

Dim S0 As String * 80
Dim S1 As String * 80 


'===============================
On_Hardware_Interrupt GoTo INT 
GoTo main
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
INT:     If PIR1.1 = 1 Then GoTo Tmr2int              ' not T2 interrupt 32+ ms           
         If PIR1.5 = 0 Then Retfie                    ' rcif interrupt       
RxINT:   If (RCSTA & 6) > 0 Then GoTo Uart_err        '          
         Inc    RxIn                                  ' ? 
         If RxIn >= 64 Then RxIn = 0 
         RxCR = RCREG             
         If RxCR = 13 Then RxCR = 0  
         If RxCR = 10 Then RxCR = 0  
         RxBuf[RxIn] = RxCR                     
RxXit:   PIR1.5 = 0                                 ' clr rcif int
         If PIR1.1 = 1 Then GoTo Tmr2int
         Retfie               
Uart_err:    RCSTA.4 = 0                   ' clear receiver status
             RCSTA.4 = 1                   ' re-enable uart
             Retfie 
'-------------------------------------------------------------------------------                           
Tmr2int: Dec T2cnt
         If T2cnt = 0 Then GoTo T_Done
         PIR1.1=0
         Retfie                         
T_Done:  T1CON.0=0
         T2CON.2=0          
         T2cnt=8              ''   HRSOut 13,10,"TCTR-",Dec T1CTR,"-",dec tctr  
         TCTR=T1CTR                                                                                                         
'-------------------------------------------------------------------------------            
Iexit:    PIR1.1=0 ' TMR1L=0 TMR1H=0 TMR2=0  T1CON.0=1 T2CON.2=1                                        
          Retfie    ' put this code in w4int start timers/ctrs
'===============================================================================
 main:      ' 32/4=8 =>.125 *16 = 2us step for TMR2 1:16
'-------------------------------------------------------------------------------        
      OSCCON = %11110000              ' 8 mhz internal  8x4=32 pll
      OSCTUNE = 0x2                   ' 0x0 default, 0xF max freq, 0x1F min freq         
      OPTION_REG = %00000000          ' 1:2  32/4=8  8/2=4mhz => .25us/step  64 
      ANSELA = 0x3                    ' AN0-RA0,AN1--RA1 analog ,all digital 
     ' anselb
      ANSELC = 0                      ' all digital bit 3,2,1,0
      IOCAP = 0                       ' RA0-1  pin change rising edge detect
      IOCAN = 0                       ' no detect falling edge
      IOCAF = 0                       ' pins that changed        
      TMR0 = 0                        ' 2US RESOLUTION 1:4 PRESCALE
'===============================================================================                                                  
      INTCON  = 0                            '
      PORTA = 0                              '
      PIE1 = 0                               '
      PIE2 = 0                               '
      ANSELA = 0x3                           ' all digital =0  
      ANSELC = 0                             ' all digital 
      ''APFCON = 0                             ' RC4=tx  RC5=rx
      APFCON0 = 0                             ' RC4=tx  RC5=rx
      APFCON1 = 0                             '  
      BAUDCON = $40                          ' rcv-idle brg16=0      
      SPBRGL = 0                             '   
      SPBRGH = 0                             '
      TRISA = %00101111                      '  Ra4 drive probe tx / enb 555
      TRISC = %00101000                      '  Rc4 = tx  rc5 rx
      OPTION_REG = %00000010                 '  wpu enb    8*.125=1 us/cnt
      WPUA = %00111000                       ' weak pullup port A
      TXSTA = 0                              '
      RCSTA = 0                              '
'------------------------------------------- '
      TXSTA.6 = 0 : RCSTA.6=0                ' set 8-bit=0
      TXSTA.5 = 1                            ' enable tx en
     ' TXSTA.4 = 0 : TXSTA.2=1 : BAUDCON.3=0  ' sync=0  brgh=1  brg16=0
     ' TXSTA.4 = 0 : TXSTA.2=0 : BAUDCON.3=0  ' sync=0  brgh=0  brg16=0
      TXSTA.1 = 0                            ' tsr 1-empty  0-full
'------------------------------------------- '
      RCSTA.7 = 1    ' SPEN = 1  enb eusart  '
      RCSTA.4 = 1    ' CREN = 0  disenb rcv  '  ================================     
'-------------------------------------------------------------------------------      
    '  FSR0H=$01                              ' Bank 3 adr 19A    TXREG = DATA 
    '  FSR0L=$9A                              '  point txreg  indf0 = data          
'------------------------------------------------------------------------------- 
'     sync=0, brgh=1, brgh16=1    or   sync=1 brgh=0  brgh16=1               
'     baud = fosc / 4[spb+1   fosc/4 /[spb+1]  32/4= 8000000/baud = spb+1
'     8m/115200=69.44 => 68   8m/230400=34.7 => 34   8m/460800=17.36 => 16
'     8m/921600=8.68 => 8
'-------------------------------------------------------------------------------
        DelayMS 2000          ' stall 2 seconds to stabilize          
        b38400
        BaudAsc = "38400"   '9600 baud"         
        DelayMS 200     ' allow baud to stabilize                
        HRSOut 13,10,"EC-16F1825 <38400>",13,10             
        GoTo Init    
'===============================================================================
Init:   T1CON = %10000100          ' RA5[TKCI] extinput 00-1:1 0-stop cnt
        T1GCON = $00               ' 1-no sync ext clk 0-ukn 1 enb TMR1
                                   ' prescale 1:64  postscale 1:16                                   
        T2CON = %01111011          ' 32/4/64/256/16= f= 30.1245cps
                                   ' 1/f = 32768 us                                                                       
        PIR1.1 = 0                 ' TMR2IF = 0  pending T2 int
        PIE1.1 = 1                 ' TMR2IE =1  enable T2 int                                                                                            
        cidx = 0                   ' set cmd index = 0
        RxCR = 0                   ' clear RxCR received        
        TemperatureCnt = 0         ' dword
        Tmr1Counter = 0            ' dword 
        AvgCnt = 1                 ' byte   16 sample counter 
        TMR1L=0                    ' count-lo
        TMR1H=0                    ' count-h         
        TMR2=0                     ' time base                          
        INTCON = $C0               ' enable GIE + PEIE '''''+ INTF         
        T1CON.0=1                  ' enable T1 counting                                            
        T2CON.2 = 1                ' timer2 started                         
        T2cnt = 8                  ' count for 8 T2 periods of 32768 us
        TCTR = 0
        ExtCnt = 0
        AvgCnt = 1
'------------------------------------------------------------------------------- 
ClearRxBuf: 
        PIE1.5 = 0                 ' disable usart int          
        PIR1.5 = 0                 ' clear RCIF pending 
        Clear RxBuf                ' clear Rx ring buffer
        RxIn = 0                   ' clear buffer in pointer
        RxOut = 0                  ' clear buffer out pointer 
        RxCR=55             
        Command=0
        CmdW=0                
        PIE1.5 = 1                 ' allow uart ints       
        INTCON = $C0    
'====================================================== DAC DAC DAC ============       
        ANSELA = 1        ' use RA0 as analog ??          THIS WORKS
        TRISA.0 = 0       ' RA0   ??
        DACCON0 = 0xE8    'dac enb, pos ref, use dac pin, fvr2buffer output ref, neg source Vss
       ' FVRCON = 0xcc    ' enb FVR , use 4.096 ref
       ' FVRCON = 0xc8    ' enb FVR , use 2.048 ref
        FVRCON = 0xc4     ' enb FVR , use 1.024 ref              
        PORTC=0 
        GoSub GetDevType  ' c = 00 parasitic / FF V+  / "F" no resp
        If C = 0 Then GoTo Init1
        GoSub CrLf
        HRSOut " Read Pwr Failed"
                       
Init1:  GoSub CmdI        ' load Kx, Kz probe group, probe K value  
      ''  gosub saveb20   ' initially write probe data into ds18b20 
        GoSub Recall      ' get THR Kx and TLR Kz  
        If C = 0 Then GoTo init2
        GoSub CrLf
        HRSOut " Recall/rsp Fail"
init2:  HRSOut  "  Kx = ",Kx," THR = ",THR,"   Kz = ",Dec Kz," TLR = ",Dec TLR,"  Porta.2 4.7k->+5"              
                                                                  
'===============================================================================                                                                                          
W4INT:  Nop                                   ' ExtCnt = TMR1 total
         PORTA.4=0                            ' scope syns ref
         PORTC = PORTC | b'00000001'          ' rc0=1 rc2=0 
         DelayMS 5
         PORTC = PORTC ^ b'00000101'          ' rc2=1 rc0=0
         DelayMS 5
         PORTC = PORTC & b'00000000'          ' rc2=0 rc0=0 
         PORTA.4=1
         DelayMS 4
            
        '''' DelayMS 3
 ''''goto w4int        
                                  ' scope syns ref           
         If RxCR = 0 Then GoSub GetRxChar     ' packet in buffer
         
'===============================================================================          
DacOut: ''' For X=0 To 31                     ' dac test save info
        '''    DACCON1 = X                    ' step 0-31 
        '''    DelayUS 100                    ' delay between steps
        ''' Next X
        '''  DACCON1 = 0                      ' back to 0                       
        ''' DelayMS 1
        ''' PORTA.4=0
        ''' DelayMS 1
'===============================================================================
         If TCTR > 0 Then                                       
            GoSub GetTemperature              '' get current temperature                                         '' rtn c = crc = 0  crc is good 
            If C <> 0 Then 
               GoSub CrLf 
               HRSOut "  CRC ERROR = ",Hex C 
            End If                                        
            GoTo ProcessT1          
         EndIf
W4X:    If T2CON.2=0 And T1CON.0=0 Then Start_Cnts ''T1CON.0=0 : T2CON.2=0 : TCTR=T1CTR
        GoTo W4INT   
'-------------------------------------------------------------------------------                   
ProcessT1:                                        '' Temperature and PulseCounts
        If AvgCnt = 1 Then                     
           ExtCnt = TCTR                          '' init pulse count
           TemperatureCnt = Temp                     '' update temperature              
        Else
           ExtCnt = ExtCnt + TCTR                 '' init temperature count 
           TemperatureCnt = TemperatureCnt + Temp '' update temperature             
        EndIf
 
        TCTR = 0
'===============================================================================        
         C=8                                     ' 8 SAMPLES
        If AvgCnt = C Then                       ' change 4 to 8 
           AvgTemperature = TemperatureCnt / C 
           AvgPulseCount = ExtCnt / C
           GoSub WINT                       
           AvgCnt = 0                      
        EndIf                    
         Inc AvgCnt         
         GoTo W4X  ''w4end           
'-------------------------------------------------------------------------------         
WINT:   GoSub ComputeTP         

HRS80P   ' output 80 + 
GoSub Compute_ppm               ' returns  Rx, Tx, Ms, Ix, Vx, Cx, work
GoSub CrLf   
HRSOut "#0 CurAPC <",Dec5 AvgPulseCount,"  CT <",Dec1 C_deg,"C /", Dec1 F_deg,"F> CurPPM    <",Dec PPM_Now_Temp,">  " 
HRSOut "KTA= ",Dec KTA," Lo= ",Dec AdrLo," Hi= ",Dec AdrHi, 
GoSub CrLf 
HRSOut "#1 AdjAPC <",Dec5 AdjustedCnt1,"  CT <25.0C /77.0F> ADJppm #1 <",Dec AdjustedPPM1,">  K = ",Dec2 Kz/10,".",Dec1 Kz//10  
GoSub CrLf         
HRSOut "#2 AdjAPC <",Dec5 AdjustedCnt2,"  CT <25.0C /77.0F> ADJppm #2 <",Dec AdjustedPPM2,">  DS18B20_",Pdata    
            
If AdrHi = 255 Then FHi = 0 : PPMhi = 0 : EndIf
         
HRS80M      
   Return
 
      GoTo W4X  ''w4end           
'=============================================================================== 
' Obtain Temperature from 1-Wire device DS18B20 
     '   Pulses @x degC = Pulses @25 degc [ 1 + .021 ( Temp -25 )]
     '    Pulses @25 degC = 1060 Pulses @28 degC / [1+.021(28-25]
     '    Pulses @25 degc = 1060 / [1+.021 (+3)] = 1060/1.06 = 1000 @ 25 degC
     
     '   Pulses@x degC = Pulses @25 degc [ 1 + .021 ( Temp -25 )]
     '    Pulses @25 degC = 940 Pulses @28 degC / [1+.021(22-25]
     '    Pulses @25 degc = 940 / [1+.021 (-3)] = 940/.94 = 1000 @ 25 degC    
'------------------------------------------------------------------------------- 
SaveB20: TRISA.2 = 1
         OWrite DQ,1,NO_PRES,[$CC,$4E,Kx,Kz,$FF]  ' SkipRom Write SP Kgrp/data 12 bit
         OWrite DQ,1,NO_PRES,[$CC,$48]            ' Copy SP xfer to eeprom 
           Repeat                                 ' wait for copysp to finish
             DelayMS 50
             ORead DQ, 4, [C]                     ' Keep reading low pulses until
           Until C <> 0                           ' DS1820 finished,18b20 may be different
Recall:  OWrite DQ,1,NO_PRES,[$CC,$B8]            ' Recall SP
           Repeat                                 ' wait for copysp to finish
             DelayMS 50
             ORead DQ, 4, [C]                     ' Keep reading low pulses until
           Until C <> 0                           ' DS1820 finished,18b20 may be different
  GoTo RSP         
'===============================================================================
GetDevType:    
    TRISA.2=1                          ' insure input   
    OWrite DQ, 1, NO_PRES,[$CC, $B4]   ' Reset,Byte Mode,SkipRom, Read PS     
    ORead DQ, 0, [Parasite]            ' no reset, byte mode 
      Pdata = "?"
      If Parasite = $00 Then Pdata = "P"                      
      If Parasite = $FF Then Pdata = "+" 
      C = 0     ' valid data 
      Return  
'-------------------------------------------------------------------------------
 NO_PRES: C = "F"          ' failed           
          Return                                              
'------------------------------------------------------------------------------- 
GetTemperature:                     ' Temp word will hold temperature 
    TRISA.2=1           
    OWrite DQ, 1, [$CC, $44]           ' Reset,Byte Mode,SkipRom,Convert  
    Repeat                             ' Parasite pwr use 2000 else 50
   If Parasite = $00 Then DelayMS 1000 ' Wait until conversion is complete 
    DelayMS 50                         '
    ORead DQ, 4, [C]                   ' Keep reading low pulses until
    Until C <> 0                       ' DS1820 finished,18b20 may be different  
RSP: OWrite DQ, 1, [$CC, $BE]           ' Reset,Byte Mode,SkipRom,Read ScratchPad 
INTCON=0        
    'ORead DQ, 2,[Temp.LowByte,Temp.HighByte] 
    ORead DQ, 2,[Temp.LowByte,Temp.HighByte, THR, TLR, DSFig, RSV5, RSV6, RSV7, CRC] 
INTCON = $C0 

''       If AvgCnt = 1 Then 
''GoSub CrLf    
''HRSOut "  DS18B20 < ",Hex Temp.LowByte," ",Hex Temp.HighByte," ",Hex THR," ",Hex TLR," ",Hex DSFig," ",Hex RSV5 ," ",Hex RSV6," ",Hex RSV7," ",Hex CRC," >"    
     CRC = 0
     For X = 0 To 8 
        CRCDATA = B20Str[X]
        GoSub CRC8
     Next X     
''HRSOut "     00-OK  CRC = ", Hex CRC     
''    End If

     C = CRC     ' good read = 0 
   Return   
'=============================================================================== 
ComputeTP:                                  ' PulseTx = PulseT25 [ 1 + .021(Ms-25)] 
      Temp = AvgTemperature    
      RSV7 = Temp.HighByte & 0x80           ' save sign bit       
      If RSV7 > 0 Then                      ' PulseT25 = PulseTx / [ 1 + .021(Ms-25)]
         Temp = (Temp ^ 0xFFFF) +1          ' 2's complement
         Temp = Temp & 0x7FF                ' trim off sign bits             
      End If                                '
      C_deg = Temp  * .0625                 ' compute Degrees C                 
      If RSV7 > 0 Then C_deg = (-1 * C_deg) ' 
      Ix = (C_deg * 1.8)                    '
      F_deg = Ix + 32                       ' compute Degrees F                                                                                 
      T1x = ((C_deg - 25) *.021) +1            ' delta temperature adj     
      AdjustedCnt1 = AvgPulseCount / T1x    ' adjusted  cnt Procedure 1
      Work = AvgPulseCount * 46.5           '
      T2x = C_deg + 21.5                       '
      AdjustedCnt2 = Work / T2x             ' adjusted  cnt Procedure 2      
      Return                                '                     
'===============================================================================                                                            
'Salinity correction approximation  5000 ppm @ 25C ==> 11000 us
'R2 = R1((T1+6.77)/(T2+6.77))  ' F  5000 ppm @ 40C ==> 8200 us   
'R2 = R1((T1+21.5)/(T2+21.5))  ' C
'11000((25 + 21.5)/(40+21.5)) = 8317 us ' 5500((25 + 21.5)/(40+21.5)) = 4158 ppm
'Rx = R25 ( T25 + 21.5 )/( Tx +21.5 )   ' R25 = Rx ( Tx + 21.5) / ( T25 + 21.5 ) 
'===============================================================================                                          
ErrorY: GoSub CrLf
        HRSOut "K = ", Dec Kz/10,".",Dec Kz//10, "   No value found this table"
        GoSub CmdVx
        Select Kx                                    ' no find select next table 
          Case "1"
            Kx = "2" : Kz = 10 : EWrite KPRB,["2"] : EWrite KDAT,[10]
          Case "2"
             Kx = "3" : Kz = 100 : EWrite KPRB,["3"] : EWrite KDAT,[100]
          Case "3"
             Kx = "4" : Kz = 150 : EWrite KPRB,["4"] : EWrite KDAT,[150]
          Case "4"
             Kx = "5" : Kz = 200 : EWrite KPRB,["5"] : EWrite KDAT,[200]
          Case "5" 
             Kx = "1" : Kz = 1 : EWrite KPRB,["1"] : EWrite KDAT,[1]
        End Select
        GoSub CrLf       
        HRSOut "Now Trying   K = ", Dec Kz/10,".",Dec Kz//10                    
        Return 
'===============================================================================
Compute_ppm:
FindLow: C = Kx                                      ' active group #
         GoSub LoadKTA                                ' get probe table location
         Kx = C        
         AdrLo = 255                                  ' invalid for addrlo
         AdrHi = 255                                  ' invalid for addrhi                  
         For C =   0 To 9                              ' 10 slot entries 
          KADR = KTA + (C * 4)                         ' calc slot address
          ESlot = ERead KADR                           ' get slot info
          CalibF = Ecnt                                ' must do to work properly 
          If CalibF <= AvgPulseCount Then AdrLo = KADR ' this will save the lowest match                     
         Next C                                         ' repeat                      
          If AdrLo = 255 Then ErrorY                  ' didn't locate low value 
          ESlot = ERead AdrLo                         ' get low slot info           
          FLo = Ecnt                                  ' save low Freq
          PPMlo = Eppm                                ' save low ppm                 
          KADR = AdrLo                                ' 
'-------------------------------------------------------------------------------                                                                                                                            
FindHigh: KADR = KADR + 4                             ' add 4 = next slot
          If KADR > KTA  + 38 Then GoTo ErrorY           ' out of range  this probe         
          ESlot = ERead KADR                             ' get next slot after low           
          CalibF = Ecnt                               ' must do to work properly                                                                         
          Temp = CalibF ^ 0xffff                      ' ecnt valid info ?
          If Temp = 0 Then GoTo FindHigh              ' not valid try next slot                                         
          If AvgPulseCount >= CalibF Then AdrHi = KADR  ' high slot addr 
          PPMhi = Eppm                                ' save high ppm                        
          FHi = Ecnt                                  ' save hi Freq       
'===============================================================================         
compute: 
       If AdrHi = AdrLo Then                          ' ppm ==> AdrHi * 50          
          PPM_Now_Temp = PPMlo  ' or ppmhi                  ' 0,1=>0 2,3=>100 4,5=>200              
          Delta_PPM=0 : Delta_Freq=0 : Slope=0 : Cx=0 '
          Return                                      '
       EndIf                                          '
       Delta_PPM = (PPMhi - PPMlo)                    ' Rx Delta Ahi-Alo * 50[ppmH-ppmL]       
       Delta_Freq = FHi - FLo                         ' Tx=> Delta Frequency freqhi - freqlo
       Slope = ((PPMhi - PPMlo) ) / Delta_Freq        ' SLOPE               
       PPM_correction = (PPMlo  ) - Slope * FLo       ' correction ppm = (ppm Lo) - (slope * freqLo)            
       Cx = (Slope * AvgPulseCount) + PPM_correction  ' conductivity = slope*freq + correction       
       PPM_Now_Temp = fRound(Cx)                      ' ppm at current temperature                                                       '                                   
      T1x = ((C_deg - 25) *.021) +1                   ' delta temperature adj     
      AdjustedPPM1 = PPM_Now_Temp / T1x               ' adjusted  cnt Procedure 1
      Work = PPM_Now_Temp * 46.5                      '
      T2x = C_deg + 21.5                              '
      AdjustedPPM2 = Work / T2x                       ' adjusted  cnt Procedure 2                                 
   Return                                                     
'===============================================================================
'  Load KTA with Current Probe Table Address from active Type #
'-------------------------------------------------------------------------------          
LoadKTA:     KTA = 255
             If C = "1" Then KTA = K1
             If C = "2" Then KTA = K2
             If C = "3" Then KTA = K3
             If C = "4" Then KTA = K4
             If C = "5" Then KTA = K5
             If KTA = 255 Then GoTo PPMerror                                                   
             Return                              
'===============================================================================
GetRxChar: RxCR=55                                      ' make RxCR  <> 0                       
           Inc RxOut                                    '
           If RxOut=64 Then RxOut=0                     ' buffer wrap  0-63-0 
           Command = RxBuf[RxOut]                       ' get the command  
HRSOut 13,10,"Cmd <",Command,             
           If Command = 0 Then  GoTo ABORT              'abort cmd - no valid data                                       
           For X = 1 To 9                               ' move RxIn to Cmd 
             Inc RxOut                                  ' z198,50000 
             If RxOut=64 Then RxOut=0                   ' buffer wrap  0-63-0  
             CMD[X] = RxBuf[RxOut]   
             HRSOut ">  Cmd[",Hex X,"] = <",Hex CMD[X],"> "                                                               
             If CMD[X] = 0 Then  Break                  ' end of string                                                                        
           Next X                                                                                                                                                                                                              
           CmdW = Val(CMD , Dec)                        ' C12345 => 12345 into work                     
           If Command="v" Then GoTo CmdVx ' View Active probe table
           If Command="V" Then GoTo CmdV ' View Active probe table
           If Command="D" Or Command="d" Then GoTo CmdD ' Display EEprom Data
           If Command="T" Or Command="t" Then GoTo CmdT ' not yet
           If Command="S" Or Command="s" Then GoTo CmdS ' not yet
           If Command="X" Or Command="x" Then GoTo CmdX ' not yet
           If Command="K" Or Command="k" Then GoTo CmdK ' save probe constant 0.1 1.0 10.0
           If Command="I" Or Command="i" Then GoTo CmdI ' Info, reset in/out ctr
           If Command="Z" Or Command="z" Then GoTo CmdZ ' Calibrate Zabbbbb
           If Command="Y" Or Command="y" Then GoTo CmdY ' Yes   a = 0-9 slot to use
           If Command="N" Or Command="n" Then GoTo CmdN ' No    b = ppm for slot 
           If Command="P" Or Command="p" Then GoTo CmdP ' Store Probe data in DS18B20               
           GoTo ABORT                                   ' bad command
'===============================================================================
CmdP:   GoSub CrLf
        HRSOut "Kx = ",Kx," THR = ---","   Kz = ",Dec Kz," TLR = ---"        
        GoSub SaveB20   ' initially write probe data into ds18b20         
        GoSub Recall    ' get THR Kx and TLR Kz
        GoSub CrLf
        HRSOut "Kx = ",Kx," THR = ",THR,"   Kz = ",Dec Kz," TLR = ",Dec TLR
        GoSub CrLf
        HRSOut "--RECALLED---"
        Return
'-------------------------------------------------------------------------------                     
CmdY:    GoTo CmdZ1
CmdN:    Return
'-------------------------------------------------------------------------------                      
CmdK:    C = CMD[1]                 ' "1","2","3","4","5"
         If C = 0 Then GoTo DVx     ' CR   read eprom K
   GoSub CrLf      
HRSOut "ADR1 <",Dec KPRB,"> = ",ERead KPRB,"  ADR2 <",Dec KDAT,">  Data <",Dec C,"-",Hex C 
         Select C
           Case "1"
              V = C : Xcnt = 1               
           Case "2"
              V = C : Xcnt = 10             
           Case "3"
              V = C : Xcnt = 100 
           Case "4"
              V = C : GoTo CMK2 
           Case "5"
              V = C : GoTo CMK2 
           Case Else
Kbad:         GoSub CrLf : HRSOut "--- K Bad Input ---"
              GoTo DVx
         End Select   
           GoTo CMK3                   '              
'-------------------------------------------------------------------------------                       
CMK2:   CMD1[1] = CMD[2]
        CMD1[2] = CMD[3]
        CMD1[3] = CMD[4]                               
        CmdW = Val(CMD1 , Dec)        ' 123  value 123  into work 
        Xcnt = CmdW.Word0            
        If Xcnt > 255 Then GoTo Kbad         
CMK3:   EWrite KPRB, [V]              ' k "1","2","3"   ' "4" "5"                       
        EWrite KDAT, [Xcnt.LowByte]                
CMKx:   Kx = ERead KPRB
        Kz = ERead KDAT
        GoSub CrLf : HRSOut "PROBE-K = ",Dec Kz/10,".",Dec Kz//10 
        HRSOut "      KPRB Eadr(",Dec KPRB,") = ",Kx,"  KDAT Eadr(",Dec KDAT, ") = ", Dec Kz                                   
        Return              
'-------------------------------------------------------------------------------                                                    
ABORT:  GoSub CrLf 
        HRSOut "Invalid CMD<",Hex Command
         Return                       
'-------------------------------------------------------------------------------                      
CmdR:    Return
'-------------------------------------------------------------------------------              
CmdT:    Return
'-------------------------------------------------------------------------------               
CmdS:    Return
'-------------------------------------------------------------------------------              
CmdX:    Return
'===============================================================================
CmdI:    Kx = ERead KPRB                                    ' load group #
         Kz = ERead KDAT                                    ' load kval x 10 #  
         GoSub CrLf       
         HRSOut "Current Probe Group = ",Kx,"  Probe K = ",Dec Kz/10,".", Dec Kz//10 
         GoSub CrLf
         HRSOut  EStr Erev
         GoSub CrLf         
         RxOut=0
         RxIn=0
         Return
'-------------------------------------------------------------------------------             
CmdD:    GoSub CrLf
         X = "=" : Y = 33 : GoSub CharOut
         HRSOut " EEPROM DUMP "
         X = "=" : Y = 33 : GoSub CharOut
         KADR = 0
         For V = 1 To 10
            For W = 0 To 4
               If W = 0 Then
                  GoSub CrLf
                  HRSOut Dec3 KADR,"> "
               End If   
               ESlot = ERead KADR
               KADR = KADR + 4
               HRSOut " ",Dec5 Eppm,",",Dec5 Ecnt 
            Next W
         Next V
DVx:   ''  X = ERead KPRB
       ''  Y = ERead KDAT
       ''  GoSub CrLf
       ''  HRSOut "K = ",Dec Y/10,".",Dec Y//10,"  Adr-<",Dec KPRB,">=<",X,">  Adr-<",Dec KDAT,">=<",Dec Y,">" 
       ''  GoSub CrLf : HRSOut "KPRB Eadr(",Dec KPRB,") = ",Kx,"  KDAT Eadr(",Dec KDAT, ") = ", Dec Kz
       ''  GoSub CrLf : HRSOut "Kx=",Kx,"  K = ",Dec Kz/10,".",Dec Kz//10    
         GoSub CMKx 
         
                    
         HRS80E         
         Return                     
'-------------------------------------------------------------------------------              
Dcrlf:   GoSub CrLf
         HRSOut Dec Y,"> "
         Return                                                                                                                                                                               
'===============================================================================
'       Display EEPROM PPM PulseCount @ ppm  must use range ????
'-------------------------------------------------------------------------------              
CmdV:    C = Kx                                     ' Active group #
         GoSub LoadKTA                              ' load current table address
         Kx = C
         KADR = KTA                                 '
         For C = 1 To 10                            '
           ESlot = ERead KADR                       '
GoSub CrLf           
HRSOut Dec3 KADR,"> ",Dec5 Eppm,",",Dec5 Ecnt   ' display data     
           KADR = KADR + 4                          '
         Next C                                     '
         GoTo DVx                                   ' display probe data
         Return  
'===============================================================================
'       Display EEPROM PPM PulseCount @ ppm  must use range ????
'-------------------------------------------------------------------------------              
CmdVx:   C = Kx                                     ' Active group #
         GoSub LoadKTA                              ' load current table address
         Kx = C
         KADR = KTA                                 '         
         For C = 1 To 10                            '
           If C = 1 Or C = 6 Then HRSOut 13,10,"KTA<",Dec3 KADR,"> "
           ESlot = ERead KADR                       '
           ''HRSOut 13,10,"KTA<",Dec3 KADR,"> "
           HRSOut  " ",Dec5 Eppm,",",Dec5 Ecnt," "   ' display data     
           KADR = KADR + 4                          '
         Next C                                     '
         GoTo DVx                                   ' display probe data
         Return                                                                                                                      
'===============================================================================
'        Store Calibration Freqency at PPM address
'-------------------------------------------------------------------------------                                  
CmdZ:  ''  Z1="Y"                                       ' preset yes  
         C = CMD[1]
         GoSub LoadKTA                                ' load current table address                                                                
         KTASlot = CMD[2] & 0x0F                      ' slot # as "0" - "9"
         If KTASlot > 9 Then GoTo PPMerror            ' Group Table PPM slot #
         KTASlot = KTASlot * 4                        ' offset is 4 bytes / slot  
         For X = 1 To 6
            CMD1[X] = CMD[X +2]
            If CMD1[X] = 0x00 Then Break
         Next X
         CmdW = Val (CMD1, Dec)                       ' get dec value remain digits      
         If CmdW > 65530 Then GoTo PPMerror           ' abort 
         PPMLoad = CmdW.Word0                         ' save as word
         KTALoad = KTA + KTASlot                      ' eprom slot address 
      GoSub CrLf                     
HRSOut "K = ",Dec Kz/10,".",Dec Kz//10," ",Command," Command, "  
      GoSub CrLf 
         HRSOut " KTA-",Dec KTA,"  KTASlot-", Dec KTASlot," KTALoad-",Dec KTALoad 
      GoSub CrLf          
         HRSOut "  PPMLoad-",Dec PPMLoad,"   Y/N  "          
         Return 
'-------------------------------------------------------------------------------            
CmdZ1: ''  Z1=""            '" what location do I write it
         EWrite KTALoad, [PPMLoad]           ' Eppm 
         EWrite KTALoad + 2, [AvgPulseCount]
         ESlot = ERead KTALoad 
         GoSub CrLf          
         HRSOut Dec Eppm,"  -  ", Dec Ecnt  
         Return            
'-------------------------------------------------------------------------------           
PPMerror:   GoSub CrLf
            HRSOut "----------------Bad Input--------------------"        
            Return                                                                                         
'===============================================================================
' ADC stuff
       '  ADC stuff     
'---- 4.096 ref       
      FVRCON = %10000011                ' enb-rdy 00=vdd 01=1024 10=2048 11=4096    
      ADCON1 = %11100011                ' RJ,fosc/64, 00=vdd 11=fvr 
'---- VDD ref    5.0v 5.2v     
   '' FVRCON = %00000000                ' enb-rdy 00=vdd 01=1024 10=2048 11=4096  
   '' ADCON1 = %11100000                ' RJ,fosc/64, 00=vdd 11=fvr
'-----------------------------------------------------------------------------      
      ANSELA = $03                      ' enable AN0 and AN1 
'------------------- ADC 0 -------------' 
      For Temp=1 To 1024                '
     PORTA.4=0                          '  1024 cycles at   khz
       DelayUS 100                      '  share probe with TX ???????????
     PORTA.4=1                          ' 
       DelayUS 100                      ' 
      Next Temp                         '
       'delayus 20                      '
'---------------------------------------'
      ADCON0 = $01                      ' select channel AN0 + ADC enabled      
      DelayUS 150                       ' aquisition time 
      ADCON0.1 = 1                      ' start conv
WH:   If ADCON0.1 = 1 Then GoTo WH      '
      ADC0 = ADC                        '
'------------------- ADC 1 -------------'      
      ADCON0 = $05                      ' select channel AN1 + ADC enabled
      DelayUS 50                        ' aquisition time 
      ADCON0.1 = 1                      ' start conv
WH1:   If ADCON0.1 = 1 Then GoTo WH1    '
       ADC1 = ADC                       '
'----------------------------------------------------------------       
       For Temp=1 To 512                '
     PORTA.4=0                          '  1024 cycles at   khz
       DelayUS 100                      ' 
     PORTA.4=1                          ' 
       DelayUS 100                      ' 
      Next Temp                         '      
'=================================================================    
      '''Resistor = 1500                   ' value of sense resistor in ohms
      Temp = ADC0 - ADC1
      Vx = (Temp) * 4                   '  Vx millivolta across R1  2956 mv                                                             
      Ix = Vx / 1500                '  Ix milliamps thru R1     1.97 ma       
      Vx = ADC1 * 4                     '  Vx millivolts across PROBE 192 mv                                              
      Rx = Vx / Ix                      '  Rx OHMs = millivolts / milliamps       
      Ms = 1000000 / Rx                 ' usiemens  97.429  10263.884      
      Vx = Ms / Tx                      ' adjusted mS  
   GoSub CrLf        
HRSOut "Rx = ",Dec Rx," Ohms => ",Dec Ms," microsiemens"," @25= ",Dec Vx     
     If  C = "F" Then 
         HRSOut  " NO temp" : GoSub CrLf 
     Else   
         'DS18B20  Read Scratch Pad Results
         ' HRSOut "Spad = "    
         ' HRSOut Hex2 Temp.HighByte,"-" ,Hex2 Temp.LowByte,"-", Hex THR,"-", Hex TLR,"-"
         ' HRSOut Hex2 DSFig,"-", Hex RSV5,"-", Hex RSV6,"-", Hex RSV7,13,10    
     EndIf
Return                                                        
'===============================================================================
CrLf:    HRSOut 13,10
         Return
'-------------------------------------------------------------------------------         
CharOut: For V = 1 To Y
           HRSOut X
         Next V
         Return
'------------------------------------------------------------------------------- 
'================================================================================================         
 CRC8:                                                 '
 Asm                                            '
              movfw   CRCDATA                          ' update last crc
              Xorwf   CRC,f                            ' xor crc and new byte
              Movlw    0                               ' clear w reg
              Btfsc   CRC,0                            '\
               Xorlw  0x5e                             ' \ 
              Btfsc   CRC,1                            '  \
               Xorlw  0xbc                             '   \
              Btfsc   CRC,2                            '    \
               Xorlw  0x61                             '     \
              Btfsc   CRC,3                            '      \
               Xorlw  0xc2                             '       |-- build new CRC
              Btfsc   CRC,4                            '       |  
               Xorlw  0x9d                             '      /
              Btfsc   CRC,5                            '     /
               Xorlw  0x23                             '    /
              Btfsc   CRC,6                            '   /
               Xorlw  0x46                             '  /
              Btfsc   CRC,7                            ' /
               Xorlw  0x8c                             '/
              Movwf   CRC                              ' save new crc value
              Return                                   '
 EndAsm  
 
End






                                        '
 
 
